--Suite.8.11.13.1-SQL.sql 10/07/2020
-- Replace <LOGIN> with the login the application will use to access the database.

IF EXISTS (SELECT
    name
  FROM sysobjects
  WHERE name = 'getGridList'
  AND type = 'P')
  DROP PROCEDURE getGridList
GO

create PROCEDURE getGridList
(
    /*
	Parameters
	Module_ID, tableName, userfieldProfile, hasSearch,
				 * searchField, searchValue, searchOp, startIndex, pageSize
	*/
	@moduleId as int,
	@tableName as varchar(50),
	@userProfileID as int,
	@hasSearch as int,
	@searchField as varchar(200),
	@searchValue as varchar(MAX),
	@searchOp as int,
	@sortDir as varchar(25),
	@startIndex as int,
	@pageSize as int,
	@sortFields as varchar(200),
	@filter as varchar(MAX),
	@tmpForTable as varchar(150),
	@userId as int,
	@totalRowCount INT OUTPUT

)
AS
BEGIN
	--- getting the parameter to create the temp table base on the table name
	declare @dropSQL as nvarchar(200)
	declare @createSQL as nvarchar(200)
	DECLARE @tempTable as varchar(250)
	declare @preProcessTmp as varchar(250)
	DECLARE @isSubsidiary as int = 0;
	declare @searchFieldType as varchar(100)
	DECLARE @v_sortFields varchar(4000)
	declare @evaluateBoolField varchar(250)

	set @v_sortFields = @sortFields

	if CHARINDEX('[sub]', @tableName) > 0
	BEGIN
		set @isSubsidiary = 1
		set @tableName = REPLACE(@tableName, '[sub]', '');
	END
	set @tempTable = '##'+@tableName+'Temp' + @tmpForTable
	print @tempTable
	-- Checking if the object exists in to the database and if it exist we'll drop it and create it
	-- again
		IF OBJECT_ID('tempdb..' + @tempTable, 'U') IS NOT NULL
		begin
			set @createSQL = 'DROP TABLE ' + @tempTable
			exec sp_executesql @createSQL
		end

		IF OBJECT_ID('tempdb..##preprocess'+@tmpForTable, 'U') IS NOT NULL
		begin
			set @createSQL = 'DROP TABLE ##preprocess' + @tmpForTable
			exec sp_executesql @createSQL
		end
		set @createSQL = 'CREATE TABLE ' + @tempTable + ' (ID int) '
		exec sp_executesql @createSQL

		set @preProcessTmp = '##preprocess'+@tmpForTable

		set @createSQL = 'CREATE TABLE ' + @preProcessTmp + '(ID int) '
		exec sp_executesql @createSQL
		if(@tableName ='MatterRelated')
		begin
			set @tableName='MatterRelationship'
		end
		else if (@tableName = 'MatterCalendar' or @tableName='Calendar')
		begin
			set @tableName = 'CalendarEvent'
		end


		DECLARE @Sql as varchar(250)
		DECLARE @counter int
		DECLARE @colName varchar(50)
		DECLARE @dataType varchar(50)
		DECLARE @length int
		DECLARE @scale as int
		declare @isPK bit
		declare @pkName nvarchar(50)
		declare @variablesList nvarchar(MAX)
		declare @declareList nvarchar(MAX)
		declare @colList nvarchar(MAX)
		declare @compColList varchar(MAX)
		declare @compJoinTables varchar(MAX)

		declare @pkValue int
		declare @colId int
		declare @ufpDataType varchar(20)
		declare @alterSqlTemp nvarchar(200)

		--SET @colName  = 'name'
		DECLARE cols CURSOR
			FOR SELECT
				distinct (c.column_id),
				c.name 'Column Name',
				t.Name 'Data type',
				CASE
				WHEN c.precision = 0
					then c.max_length
					else c.precision
				end as 'MaxLength',
				c.scale 'scale',
				i.is_primary_key
			FROM
				sys.columns c
			INNER JOIN
				sys.types t ON c.user_type_id = t.user_type_id
			LEFT OUTER JOIN
				sys.index_columns ic ON ic.object_id = c.object_id AND ic.column_id = c.column_id
			LEFT OUTER JOIN
				sys.indexes i ON ic.object_id = i.object_id AND ic.index_id = i.index_id
			WHERE
				c.object_id = OBJECT_ID(@tableName);

		-- declare the values of the variable running
		declare @vName nvarchar(150)
		declare @dName nvarchar(150)
		declare @cName nvarchar(150)
		OPEN cols;
		FETCH NEXT FROM cols INTO
			@colId,
			@colName,
			@dataType,
			@length,
			@scale,
			@isPK;

		WHILE @@FETCH_STATUS = 0
			BEGIN
				if @dataType = 'image'
				begin
					set @cName = 'cast( t.' + @colName + ' as varbinary(MAX)) as ' + @colName
				end
				else
				begin
					set @cName = 't.' + @colName
				end
				if(@colList is null or @colList = '')
				begin
					set @colList = @cName
				end
				else
				begin
					set @colList = @colList + ',' + @cName
				end
				if @isPK = 1
				begin
					-- setting name of pk for the current table
					set @pkName = @colName
				end
				if @colName = @searchField
				begin
					set @searchFieldType = @dataType
				end
				select @vName = dbo.chainVariable(@colName,@dataType,@length,@scale,@variablesList,1)
				-- getting variables list to be used into the fetch of the data
				if(@variablesList is null or @variablesList = '')
				begin
					set @variablesList = @vName
				end
				else
				begin
					set @variablesList = @variablesList + ',' + @vName
				end

				-- list of the declaration of the variables
				select @dName = dbo.chainVariable(@colName,@dataType,@length,@scale,@declareList,0)

				if (@declareList is null or @declareList = '')
				begin
					set @declareList = 'DECLARE ' + @dName
				end
				else
				begin
					set @declareList = @declareList + ',' + @dName
				end

				if @dataType= 'int' or @dataType = 'datetime' or @dataType = 'bigInt'
				begin
					SET @Sql = 'ALTER TABLE ' + @tempTable + ' ADD [' + @colName + '] '+@dataType
					SET @alterSqlTemp = 'ALTER TABLE ' + @preProcessTmp + ' ADD [' + @colName + '] '+@dataType
				end
				else if @dataType = 'numeric' or @dataType = 'decimal'
				begin
					SET @Sql = 'ALTER TABLE ' + @tempTable + ' ADD [' + @colName + '] '+ @dataType + '(' +cast(@length as nvarchar) + ',' + CAST(@scale as nvarchar) + ')'
					SET @alterSqlTemp = 'ALTER TABLE ' + @preProcessTmp + ' ADD [' + @colName + '] '+ @dataType + '(' +cast(@length as nvarchar) + ',' + CAST(@scale as nvarchar) + ')'
				end
				else if @dataType = 'char' or @dataType = 'varchar' or @dataType = 'nvarchar'
				begin
					SET @Sql = 'ALTER TABLE ' + @tempTable + ' ADD [' + @colName + '] '+@dataType+'('+cast(@length as nvarchar)+')'
					SET @alterSqlTemp = 'ALTER TABLE ' + @preProcessTmp + ' ADD [' + @colName + '] '+@dataType+'('+cast(@length as nvarchar)+')'
				end
				else if @dataType = 'image'
				begin
					SET @Sql = 'ALTER TABLE ' + @tempTable + ' ADD [' + @colName + '] '+ 'varbinary(MAX)'
					SET @alterSqlTemp = 'ALTER TABLE ' + @preProcessTmp + ' ADD [' + @colName + '] '+'varbinary(MAX)'
				end

				EXEC (@Sql)
				exec (@alterSqlTemp)

				FETCH NEXT FROM cols INTO
					@colId,
					@colName,
					@dataType,
					@length,
					@scale,
					@isPK;
			END;
		close cols;
		deallocate cols;

		if(@searchField = 'matter.matterName' and @moduleId = 4)
		begin
			SET @Sql = 'ALTER TABLE ' + @tempTable + ' ADD MatterName varchar(MAX)'
			EXEC (@Sql)

			SET @Sql = 'ALTER TABLE ' + @preProcessTmp + ' ADD MatterName varchar(MAX)'
			EXEC (@SQL)
		end

		SET @Sql = 'ALTER TABLE ' + @tempTable + ' ADD [UserFieldValue] varchar(MAX)'
		EXEC (@Sql)

		SET @Sql = 'ALTER TABLE ' + @preProcessTmp + ' ADD [UserFieldValue] varchar(MAX)'
		EXEC (@Sql)

		SET @Sql = 'ALTER TABLE ' + @preProcessTmp + ' ADD [rowOrder] varchar(MAX)'
		EXEC (@Sql)

		if ((@pkName IS NULL) OR (LEN(@pkName) = 0)) and @tableName = 'V_Entlist' -- for entities view
		begin
			set @pkName = 'EntityID'
		end
		if ((@pkName IS NULL) OR (LEN(@pkName) = 0)) and @tableName = 'V_PeopleList' -- for people view
		begin
			set @pkName = 'Entity_EID'
		end

		else if ((@pkName IS NULL) OR (LEN(@pkName) = 0)) and @tableName = 'Mem'
		-- make the selection into the neew table, remeber first value is the same as the pk so it will be the veryfirst column of each table
		Declare @preSql as varchar(max)
		declare @fullFilter as varchar(max)
		declare @fullF as varchar(max)
		declare @sortCrit as varchar(max)
		set @fullFilter = ''
		set @fullF = ''
		set @sortCrit = ''

		if ((@filter IS NOT NULL) and (LEN(@filter) > 0))
		begin
			/*Filter will come as the master id when in subtabs, however, it comes as different name of the field in the subtabs tables*/
			--Non standard name for allocation approval and details on InvoiceModules
			if(@moduleId = 4 and (@tableName = 'InvoiceDetail' or @tableName='InvoiceApproval' or @tableName='InvoiceAllocation'))
			begin
				set @filter = REPLACE(@filter, 'Invoice_ID', 'MatterInvoiceNumber_ID');
				set @searchField = REPLACE(@searchField, 'adjustedPreTaxNativeAmount', 'adjustednativeamountpretax');
			end
			if(@moduleId = 4 and @tableName = 'Invoice')
			begin
				set @filter = REPLACE(@filter, ' Invoice_ID ', ' t.Invoice_ID ')
				set @searchField = REPLACE(@searchField, 'adjustedPreTaxNativeAmount', 'adjustednativeamountpretax');
				if CHARINDEX('t.', @filter) = 0
				begin
					set @filter = REPLACE(@filter, '(Invoice_ID ', ' (t.Invoice_ID ')
				end
				if CHARINDEX('t.', @filter) = 0
				begin
					set @filter = REPLACE(@filter, 'invoice_id ', ' t.Invoice_ID ')
				end
			end

			if(@tableName = 'Member') or (@tableName = 'Registration')
			begin
				if @moduleId = 52 -- people module for Outside Affiliation tab
				begin
					set @filter = REPLACE(@filter, 'Entity_EID', 'RelatedEntity_EID');
				end
				else
				begin
					set @filter = REPLACE(@filter, 'Entity_EID', 'Company_ID');
				end
			end
			if(@tableName='V_Entlist' )
			begin
				set @filter = REPLACE(@filter, 'entity_eid', 'EntityID');
			end
			if(@tableName='V_PeopleList' )
			begin
				set @searchField = REPLACE(@searchField, 'middleName', 'middle');
				set @searchField = REPLACE(@searchField, 'prefix', 'salutation');
			end
			if(@tableName='MatterExposure' )
			begin
				set @searchField = REPLACE(@searchField, 'exposureType_cd', 'Type_cd');
			end
			if @tableName = 'InsurancePolicy'
			begin
				set @filter = REPLACE(@filter, 'Entity_EID', 'InsuranceCompany_ID');
			end
			if (@tableName = 'GoodService') or (@tableName = 'Opposition')
			begin
				set @filter = REPLACE(@filter, 'MatterNumber_ID', 't.trademark_id');
			end
			if @tableName ='MatterInsuranceClaim'
			begin
				set @filter = REPLACE(@filter, 'MatterNumber_ID', 'Matter_InsurancePolicy_ID');
			end
			if @tableName ='MatterLitigationJudge'
			begin
				set @filter = REPLACE(@filter, 'MatterNumber_ID', 't.MATTERLITIGATION_ID');
			end	
			
			set @fullFilter = ' AND ' + @filter
			set @fullF =  ' WHERE ' + @filter
		end


		if LEN(@fullFilter) > 0
		begin
			declare @tIndex int;
			declare @strTest varchar(25);

			set @tIndex = CHARINDEX('TYPE_CD', @fullFilter)

			if(@tIndex > 0)
			begin
				set @strTest = SUBSTRING(@fullFilter, (@tIndex-2), 2)
				if(CHARINDEX(',',@strTest)>0) or (CHARINDEX(' ', @strTest)>0) or (CHARINDEX('(', @strTest)>0)
				begin
					set @fullFilter = REPLACE(@fullFilter,'TYPE_CD','t.TYPE_CD')
					set @fullF = REPLACE(@fullF,'TYPE_CD','t.TYPE_CD')
				end
			end
			else
			begin
				set @fullFilter = REPLACE(@fullFilter,'TYPE_CD','t.TYPE_CD')
				set @fullF = REPLACE(@fullF,'TYPE_CD','t.TYPE_CD')
			end
			if(@tableName = 'V_Entlist' )
			begin
				set @fullFilter = REPLACE(@fullFilter,'STATUS_CD','t.Status')
				set @fullF = REPLACE(@fullF,'STATUS_CD','t.Status')
			end
			else
			begin
				if CHARINDEX('MatterStatus_CD', @fullFilter) > 0
				begin
					set @fullFilter = REPLACE(@fullFilter,'MatterSTATUS_CD','t.MatterSTATUS_CD')
				set @fullF = REPLACE(@fullF,'MatterSTATUS_CD','t.MatterSTATUS_CD')
				end
				else if CHARINDEX('InvoiceStatus_CD', @fullFilter) > 0
				begin
					set @fullFilter = REPLACE(@fullFilter,'InvoiceStatus_CD','t.InvoiceStatus_CD')
					set @fullF		= REPLACE(@fullF,'InvoiceStatus_CD','t.InvoiceStatus_CD')
				end
				else
				begin
					set @fullFilter = REPLACE(@fullFilter,'STATUS_CD','t.STATUS_CD')
					set @fullF = REPLACE(@fullF,'STATUS_CD','t.STATUS_CD')
				end
			end
		end
		if @tableName = 'Ownership'
		begin
			if LEN(@fullFilter) > 0
			begin
				if(@isSubsidiary > 0)
				begin
					set @fullFilter = REPLACE(@fullFilter,'Entity_EID','t.Owner_EID')
					set @fullF = REPLACE(@fullF,'Entity_EID','t.Owner_EID')
				end
				else
				begin
					set @fullFilter = REPLACE(@fullFilter,'Entity_EID','t.COMPANY_ID')
					set @fullF = REPLACE(@fullF,'ENTITY_EID','t.COMPANY_ID')
				end
			end
		end
		if @tableName = 'FormerName' or @tableName = 'DBAName' or @tableName='AlternateName'
		begin
			if LEN(@fullFilter) > 0
			begin
				set @fullFilter = REPLACE(@fullFilter,'Entity_EID','t.COMPANY_ID')
				set @fullF = REPLACE(@fullF,'ENTITY_EID','t.COMPANY_ID')
			end
		end

		declare @composedFilter varchar(250)
		--Checking if composed field
		if CHARINDEX('.', @searchField) > 0
		begin
			--checking if it's a player
			if CHARINDEX('player', @searchField) > 0 or CHARINDEX('entity', @searchField) > 0 or CHARINDEX('billingEntity', @searchField) > 0 
			begin
				if(@searchField = 'billingEntity.name')
				begin
					set @composedFilter = 'BillingEntity_EID IN( SELECT Entity_EID from Entity **SETFILTER** ) '
				end
				else
				begin
					set @composedFilter = 'Entity_EID IN( SELECT Entity_EID from Entity **SETFILTER** ) '
				end
			end
			if CHARINDEX('logicalGroup',@searchField) > 0
			begin
				set @composedFilter = 'LOGICALGROUP_ID IN ( SELECT LOGICALGROUP_ID from LOGICALGROUP **SETFILTER** )'
			end
			if CHARINDEX('authorizedBy', @searchField) > 0
			begin
				set @composedFilter = 'AuthorizedBy_EID IN( SELECT EntityID from V_EntList **SETFILTER** ) '
			end
			if CHARINDEX('enteredBy', @searchField) > 0
			begin
				set @composedFilter = 'ENTEREDBY_ID IN( SELECT USER_ID from USERS **SETFILTER** ) '
			end
			if CHARINDEX('vendor', @searchField) > 0
			begin
				set @composedFilter = 'BillingEntity_EID IN( SELECT Entity_EID from Entity **SETFILTER** ) '
			end
			if CHARINDEX('employee', @searchField) > 0
			begin
				set @composedFilter = 'Employee_EID IN( SELECT Entity_EID from Entity **SETFILTER** ) '
			end
			if CHARINDEX('professional', @searchField) > 0
			begin
				set @composedFilter = 'Professional_EID IN( SELECT Entity_EID from Entity **SETFILTER** ) '
			end
			if CHARINDEX('professionalVendor', @searchField) > 0
			begin
				set @composedFilter = 'professionalVendor_EID IN( SELECT Entity_EID from Entity **SETFILTER** ) '
			end
			if CHARINDEX('allocation', @searchField) > 0
			begin
				set @composedFilter = 'Allocation_EID  IN( SELECT Entity_EID from Entity **SETFILTER** ) '
			end
			if CHARINDEX('dbaEntity', @searchField) > 0
			begin
				set @composedFilter = 'DBA_EID IN( SELECT Entity_EID from V_SecrEntList **SETFILTER** ) '
			end
			if CHARINDEX('alternateEntity', @searchField) > 0
			begin
				set @composedFilter = 'Alternate_EID IN( SELECT Entity_EID from V_SecrEntList **SETFILTER** ) '
			end
			if CHARINDEX('holderEntity', @searchField) > 0
			begin
				set @composedFilter = 'HolderName_EID IN( SELECT Entity_EID from V_SecrEntList **SETFILTER** ) '
			end
			if CHARINDEX('beneficialOwnerEntity', @searchField) > 0
			begin
				set @composedFilter = 'BeneficialOwner_EID IN( SELECT Entity_EID from V_SecrEntList **SETFILTER** ) '
			end
			if CHARINDEX('acquiredEntity', @searchField) > 0
			begin
				set @composedFilter = 'Acquired_EID IN( SELECT Entity_EID from V_SecrEntList **SETFILTER** ) '
			end
			if CHARINDEX('formerEntity', @searchField) > 0
			begin
				set @composedFilter = 'Former_EID IN( SELECT Entity_EID from V_SecrEntList **SETFILTER** ) '
			end
			if CHARINDEX('Agent', @searchField) > 0
			begin
				set @composedFilter = 'Agent_ID IN( SELECT Entity_EID from V_SecrEntList **SETFILTER** ) '
			end
			--search by jurisdiction
			if CHARINDEX('Jurisdiction', @searchField) > 0
			begin
				set @composedFilter = 'Jurisdiction_ID IN( SELECT Jurisdiction_ID from Jurisdiction **SETFILTER** ) '
			end
			else if CHARINDEX('matter', @searchField) > 0
			begin
				if @moduleId = 4
				begin
					SET @compColList = ', m.MatterName'
					SET @compJoinTables = ' inner join matterinvoice mi on t.INVOICE_ID = mi.INVOICE_ID inner join matter m on m.MATTERNUMBER_ID = mi.MATTERNUMBER_ID'
					SET @variablesList = @variablesList + ' , @matterName'
					SET @declareList = @declareList + ',@matterName varchar(MAX)'
					SET @composedFilter = '**SETFILTER**'
				end
				else if @moduleId = 2 and @searchField = 'relatedMatter.matterName'
				begin
					SET @composedFilter = 'relatedmatter_ID IN (SELECT MatterNumber_ID from Matter **SETFILTER** ) '
				end
				else if @moduleId = 3 and @tableName = 'Evaluation' and @searchField = 'relatedMatter.matterName'
				begin
					SET @composedFilter = 'relatedmatter_ID IN (SELECT MatterNumber_ID from Matter **SETFILTER** ) '
				end
				else if @moduleId = 1 and @searchField = 'relatedMatter.matterNumber'
				begin
					SET @composedFilter = 'RelatedMatterNumber_ID IN (SELECT MatterNumber_ID from Matter **SETFILTER** ) '
				end
				else if @moduleId = 1 and @tableName = 'MatterRelationship' and @searchField = 'relatedMatter.mattername'
				begin
					SET @composedFilter = 'RelatedMatterNumber_ID IN (SELECT MatterNumber_ID from Matter **SETFILTER** ) '
				end
				else if @moduleId = 1 and @tableName = 'MatterRelationship' and @searchField = 'relatedMatter.matter_cd'
				begin
					SET @composedFilter = 'RelatedMatterNumber_ID IN (SELECT MatterNumber_ID from Matter **SETFILTER** ) '
				end
				else if @moduleId = 1 and @tableName = 'MatterRelationship' and @searchField = 'relatedMatter.matterStatus_cd'
				begin
					SET @searchField = REPLACE(@searchField,'relatedMatter.matterStatus_cd','matterStatus_CD')
					SET @composedFilter = 'RelatedMatterNumber_ID IN (SELECT MatterNumber_ID from Matter **SETFILTER** ) '
				end
				else
				begin
					set @composedFilter = 'MatterNumber_ID IN (SELECT MatterNumber_ID from Matter  **SETFILTER** ) '
				end
			end
			else if CHARINDEX('company', @searchField) > 0
			begin
				if @moduleId = 52 ---people module outside affiliation
					set @composedFilter = 'COMPANY_ID IN (SELECT EntityID from V_Entlist  **SETFILTER**) '
				else
					set @composedFilter = 'RelatedEntity_EID IN (SELECT EntityID from V_Entlist  **SETFILTER**) '
			end
			else if CHARINDEX('invoice', @searchField) > 0
			begin
				set @composedFilter = 'Invoice_ID in (SELECT Invoice_ID from Invoice  **SETFILTER**) '
			end
			else if CHARINDEX('title', @searchField) > 0
			begin
				set @composedFilter = 'Title_ID in (SELECT Title_ID from Title  **SETFILTER**) '
			end
			else if CHARINDEX('relationshipClass', @searchField) > 0
			begin
				set @composedFilter = 'RELATIONSHIPCLASS_ID in (SELECT RELATIONSHIPCLASS_ID from RELATIONSHIPCLASS **SETFILTER**) '
			end
			else if CHARINDEX('relatedEntity', @searchField) > 0
			begin
				set @composedFilter = 'RELATEDENTITY_EID in (SELECT Entity_EID from V_SecrEntList  **SETFILTER**) '
			end
			else if CHARINDEX('fromParty.name', @searchField) > 0
			begin
				set @composedFilter = 'FROMPARTY_EID in (SELECT Entity_EID from Entity  **SETFILTER**) '
			end
			else if CHARINDEX('toParty.name', @searchField) > 0
			begin
				set @composedFilter = 'TOPARTY_EID in (SELECT Entity_EID from Entity  **SETFILTER**) '
			end
			else if CHARINDEX('party', @searchField) > 0
			begin
				set @composedFilter = 'PARTY_EID in (SELECT Entity_EID from Entity  **SETFILTER**) '
			end
			else if CHARINDEX('owner', @searchField) > 0
			begin
				set @composedFilter = 'OWNER_EID in (SELECT ENTITY_EID from V_SecrEntList  **SETFILTER**) '
			end
		end
		if CHARINDEX('phase.ACCA', @searchField) > 0
		begin
			set @composedFilter = 'phase_id in (SELECT Phase_ID from Phase **SETFILTER**) '
		end
		if CHARINDEX('task.ACCA', @searchField) > 0
		begin
			set @composedFilter = 'Task_ID in (SELECT Task_ID from Task **SETFILTER**) '
		end
		if CHARINDEX('insuranceCompany.name', @searchField) > 0
		begin
			set @composedFilter = 'InsuranceCompany_ID IN(SELECT Entity_EID from Entity  **SETFILTER**)'
		end
		if CHARINDEX('insuranceCompany_policy.policyNumber',@searchField) > 0
		begin
			set @composedFilter = 'InsuranceCompany_Policy_ID IN(SELECT InsuranceCompany_Policy_ID FROM InsurancePolicy **SETFILTER**)'
		end
		if CHARINDEX('claimantName.name', @searchField) > 0
		begin
			set @composedFilter = 'ClaimantName_EID IN(SELECT ENTITY_EID from Entity **SETFILTER**)'
		end
		if CHARINDEX('judge.name', @searchField) > 0
		begin
			set @composedFilter = 'Judge_EID IN (SELECT Entity_EID from V_PeopleList **SETFILTER**)'
		end									  
		if CHARINDEX('status_cd', @searchField) > 0 and @moduleId = 3
		begin
			set @searchField = REPLACE(@searchField,'status_cd','Status')
		end
		if @searchField = 'administrationNumber' and @tableName = 'MatterPlayer'
		begin
			set @composedFilter = 'Entity_EID IN (SELECT Person_ID from Person **SETFILTER**) '
		end
		if @searchField = 'owner.userName'
		begin
			set @composedFilter = 'Owner_ID IN (SELECT User_ID from Users **SETFILTER**) '
		end
		if @searchField = 'hasDocuments' and @searchValue = 'F'
		begin
		    SET @evaluateBoolField = 'or hasDocuments IS NULL'
		end
		if @searchField = 'taxable' and @tableName = 'InvoiceDetail'
		begin
			set @searchField = REPLACE(@searchField,'taxable','IsTaxable')
		end

		--checking UF datatype if it comes by
		--get Data type for the userfield
		select @ufpDataType=DataType  from UserFieldProfile where UserFieldProfile_ID = @userProfileID

		if(@tableName='MatterExposure' )
			begin
				set @v_sortFields = REPLACE(@v_sortFields, 'exposureType_cd', 'Type_cd');
			end

		if(@tableName='V_PeopleList' )
			begin
				set @v_sortFields = REPLACE(@v_sortFields, 'prefix', 'salutation');
			end
		if(@moduleId = 4 )
			begin
				set @v_sortFields = REPLACE(@v_sortFields, 'adjustedPreTaxNativeAmount', 'adjustednativeamountpretax');
			end
		if @tableName = 'InvoiceDetail'
			begin
				set @v_sortFields = REPLACE(@v_sortFields, 'taxable', 'IsTaxable');
			end


		--sortCriteria
		if ((@v_sortFields is not null) and (LEN(@v_sortFields) > 0))
		begin
			set @sortCrit = ' ORDER BY  rowOrder desc, ' + @v_sortFields
		end
		else
		begin
			set @sortCrit = ' ORDER BY rowOrder desc'
		end

		-- remember get the limits
		set @preSql = 'INSERT INTO ' + @preProcessTmp
		+' select t.' + @pkName + ' as ID,' + @colList +
		CASE WHEN @compColList IS NOT NULL
		THEN @compColList + ' '
		ELSE + ' '
		END
		+ ',null UserFieldValue, 1 as rowOrder from ' + @tableName + ' as t ' +
		CASE WHEN @compJoinTables IS NOT NULL
		THEN @compJoinTables + ' '
		ELSE + ' '
		END
		+ @fullF
		+ ' UNION '
		+ ' select t.' + @pkName + ' as ID,' + @colList +
		CASE WHEN @compColList IS NOT NULL
		THEN @compColList + ', '
		ELSE + ', '
		END
		+ 'CASE WHEN uf.DateField IS NOT NULL'
		+ ' then convert(varchar,CAST(convert(varchar, convert(datetime, uf.DateField ,101), 101) as datetime),101)
			else
			case
				when uf.UserFieldValue is not null
				then uf.UserFieldValue
				else
					case
						when uf.NumberField is not null
						then cast(uf.NumberField as varchar(25))
						else
							case
								when uf.StringField is not null
								then uf.StringField
								end
						end
					end
				end
	As UserFieldValue, 2 as rowOrder from ' + @tableName + ' as t
		left join UserField as uf on uf.Row_ID = t.' + @pkName +
		CASE WHEN @compJoinTables IS NOT NULL
		THEN @compJoinTables + ' '
		ELSE + ' '
		END
		+ ' where uf.Module_ID = ' + cast(@moduleId as nvarchar) +
		' and uf.UserFieldProfile_ID=' + cast(@userProfileID as nvarchar) + @fullFilter +  @sortCrit

		exec(@preSql);

		--count records
		declare @sqlCounter nvarchar(250)
		declare @cUnit int
		set @sqlCounter= 'SELECT @cUnit=count( distinct ' + @pkName + ') from  ' + @preProcessTmp;
		exec sp_executeSQl @sqlCounter, N'@cUnit int output', @cUnit output
		set @totalRowCount = @cUnit

		declare @sqlCursor as varchar(max)
		declare @dateFormat as varchar(30)

		--get the format used by the user
		if(@ufpDataType = 'Date/Time' or @searchFieldType = 'datetime')
		begin
		SELECT @dateFormat = PreferenceValue FROM Preference where Item = 'SHORT_DATE_FORMAT' and User_ID = @userId;
		end

		if ((@dateFormat is null) or (@dateFormat = ''))
		begin
			set @dateFormat = 'MM/dd/yyyy'
		end

		if(@hasSearch = 1)
		begin
			declare @searchPart as varchar (Max)
			declare @searchValueCol1 as varchar (Max)
			declare @searchValueCol2 as varchar (Max)

			if @searchOp = 1 --equals
			begin
				if (@ufpDataType = 'Date/Time' and @searchField = 'UserFieldValue')
				begin
					set @searchPart = ' where ' + @searchField + '=''' + dbo.convertDate(@dateFormat,@searchValue) +''''
				end
			else
				begin
					if (@searchField = 'phase.ACCA' and @tableName = 'InvoiceDetail')
					begin
						set @searchValue = REPLACE(@searchValue,' - ','.')
						set @searchValueCol1 = ParseName(@searchValue,2)
						set @searchValueCol2 = ParseName(@searchValue,1)
						set @searchPart = ' where ' + @searchField + '=''' + @searchValueCol1 + ''' AND PhaseName =''' + @searchValueCol2 + ''''
					end
					else if (@searchField = 'task.ACCA' and @tableName = 'InvoiceDetail')
					begin
						set @searchValue = REPLACE(@searchValue,' - ','.')
						set @searchValueCol1 = ParseName(@searchValue,2)
						set @searchValueCol2 = ParseName(@searchValue,1)
						set @searchPart = ' where ' + @searchField + '=''' + @searchValueCol1 + ''' AND TaskName =''' + @searchValueCol2 + ''''
					end
					else if (@evaluateBoolField IS NOT NULL)
					begin
						set @searchPart = ' where ' + @searchField + '=''' + @searchValue+ '''' + @evaluateBoolField +''
					end
					else
					begin
						set @searchPart = ' where ' + @searchField + '=''' + @searchValue+''''
					end
				end
			end
			else if @searchOp = 2 --contains like
			begin
				if (@searchField = 'phase.ACCA' and @tableName = 'InvoiceDetail')
				begin
					set @searchValue = REPLACE(@searchValue,' - ','.')
					set @searchValueCol1 = ParseName(@searchValue,2)
					set @searchValueCol2 = ParseName(@searchValue,1)
					if (@searchValueCol1 IS NOT NULL AND @searchValueCol2 IS NOT NULL)
					begin
						set @searchPart = ' where ' + @searchField + ' like ''%' + @searchValueCol1 + '%'' AND PhaseName like ''%' + @searchValueCol2 + '%'''
					end
					else
					begin
						set @searchPart = ' where ' + @searchField + ' like ''%' + @searchValue + '%'' OR PhaseName like ''%' + @searchValue + '%'''
					end
				end
				else if (@searchField = 'task.ACCA' and @tableName = 'InvoiceDetail')
				begin
					set @searchValue = REPLACE(@searchValue,' - ','.')
					set @searchValueCol1 = ParseName(@searchValue,2)
					set @searchValueCol2 = ParseName(@searchValue,1)
					if (@searchValueCol1 IS NOT NULL AND @searchValueCol2 IS NOT NULL)
					begin
						set @searchPart = ' where ' + @searchField + ' like ''%' + @searchValueCol1 + '%'' AND TaskName like ''%' + @searchValueCol2 + '%'''
					end
					else
					begin
						set @searchPart = ' where ' + @searchField + ' like ''%' + @searchValue + '%'' OR TaskName like ''%' + @searchValue + '%'''
					end
				end
				else
				begin
					set @searchPart = ' where ' + @searchField + ' like ''%' + @searchValue + '%'''
				end
			end
			else if @searchOp = 3 --starts with like %
			begin
				set @searchPart = ' where ' + @searchField + ' like ''' + @searchValue + '%'''
			end
			else if @searchOp = 4 --Greater than
			begin
				if (@ufpDataType = 'Number' and @searchField = 'UserFieldValue')
				begin
					set @searchPart = ' where ' + @searchField + ' >  cast(''' + @searchValue + ''' as numeric)'
				end
				else if (@ufpDataType = 'Date/Time' and @searchField = 'UserFieldValue')
				begin
					set @searchPart = ' where PARSE(dbo.convertDate(''MM.dd.yyyy'',' + @searchField + ') as date) > dbo.convertDate(''' + @dateFormat + ''',''' + @searchValue + ''')'
				end
				else if (@searchFieldType = 'datetime' or @searchFieldType='date')
				begin
					set @searchPart = ' where PARSE(dbo.convertDate(''MM.dd.yyyy'',' + @searchField + ') as date) > dbo.convertDate(''' + @dateFormat + ''',''' + @searchValue + ''')'
				end
				else
				begin
					set @searchPart = ' where ' + @searchField + ' > ''' + @searchValue + ''''
				end
			end
			else if @searchOp = 5 --Less than
			begin
				if (@ufpDataType = 'Number' and @searchField = 'UserFieldValue')
				begin
					set @searchPart = ' where ' + @searchField + ' <  cast(' + @searchValue + ' as numeric)'
				end
				else if (@ufpDataType = 'Date/Time' and @searchField = 'UserFieldValue')
				begin
					set @searchPart = ' where PARSE(dbo.convertDate(''MM.dd.yyyy'',' + @searchField + ') as date) < dbo.convertDate(''' + @dateFormat + ''',''' + @searchValue + ''')'
				end
				else if (@searchFieldType = 'datetime')
				begin
					set @searchPart = ' where PARSE(dbo.convertDate(''MM.dd.yyyy'',' + @searchField + ') as date) < dbo.convertDate(''' + @dateFormat + ''',''' + @searchValue + ''')'
				end
				else
				begin
					set @searchPart = ' where ' + @searchField + ' < ''' + @searchValue + ''''
				end
			end
			else
			begin
				set @searchPart = ''
			end
			if LEN(@composedFilter) > 0 and LEN(@searchPart) > 0
			begin
				declare @val varchar(100)
				set @val = @searchField
				declare @start int
				set @start = CHARINDEX('.', @val)
				declare @size int;
				set @size = LEN(@val) - @start
				declare @nFieldSearch varchar(100)
				set @nFieldSearch = SUBSTRING(@val, (@start+1), @size)
				set @searchPart = REPLACE(@searchPart,@searchField,@nFieldSearch)
				set @searchPart = case when @composedFilter ='**SETFILTER**' then '' + REPLACE(@composedFilter, '**SETFILTER**', @searchPart) else ' WHERE ' + REPLACE(@composedFilter, '**SETFILTER**', @searchPart) end;
			end
			set @sqlCursor ='DECLARE tResults CURSOR FOR
						 WITH Results_CTE AS
						(
							SELECT
								*,
								ROW_NUMBER() OVER ( ' + @sortCrit + ') AS RowNum
								FROM ' + @preProcessTmp + ' ' + @searchPart + '

						)
						SELECT *
						FROM Results_CTE'
		end
		else
		begin
			set @sqlCursor = 'DECLARE tResults CURSOR FOR
						 WITH Results_CTE AS
						(
							SELECT
								*,
								ROW_NUMBER() OVER ( ' + @sortCrit + ') AS RowNum
								FROM ' + @preProcessTmp + '

						)
						SELECT *
						FROM Results_CTE'
		end

	declare @fetchAM varchar(8000)

	set @fetchAM = @sqlCursor + ';
	OPEN tResults;
	' + @declareList  + ';
	declare @userFieldValue nvarchar(max);
	declare @idNM as int;
	declare @rowOrder as int;
	declare @nRow as int'
	+ '
	FETCH NEXT FROM tResults INTO @idNM,' +@variablesList  +',@userFieldValue ,@rowOrder,@nRow '
	+'
	WHILE @@FETCH_STATUS = 0
			BEGIN '
	+ '
	DECLARE @exists int = 0;'
	+ '
	SELECT @exists = COUNT(*) FROM ' + @tempTable + ' WHERE ' + @tempTable +'.ID = @' + @pkName +''
	+ '
	if @exists = 0
		begin

			INSERT INTO ' + @tempTable + ' values(@idNM,' + @variablesList + ', @userFieldValue);
		end'
	+ '
	FETCH NEXT FROM tResults INTO @idNM,' +@variablesList  +',@userFieldValue,@rowOrder,@nRow
	END

	close tResults;
	deallocate tResults;';

	exec(@fetchAm)

   -- count again the results when there's a search
   -- Left commented out because I need to figure out which would be a better
   -- way to get the counter when there's a search involved, because the current way
   -- will be agreed with the page size and not the actual results
   if(@hasSearch = 1)
   begin
		set @sqlCounter= 'SELECT @cUnit=count(distinct ' + @pkName + ') from  ' + @tempTable;
		exec sp_executeSQl @sqlCounter, N'@cUnit int output', @cUnit output
		set @totalRowCount = @cUnit
   end

END
go

if (select name from sysobjects
    where xtype = 'TR'
    and name = 'updUFTable') = 'updUFTable'
begin
    drop trigger updUFTable
    print 'Dropped trigger.'
    print ''
end
else
    print 'The command(s) completed successfully.'
    print ''
go

create TRIGGER updUFTable
ON UserFieldProfile
for  UPDATE
AS
BEGIN
----Declaring variables to UPDATE
DECLARE @tabId int
DECLARE @typeCd varchar(40)
DECLARE @description varchar(100)
DECLARE @position int
DECLARE @required varchar(1)
DECLARE @typeCat int
DECLARE @ufprofileID int
DECLARE @changeBy varchar(20)

select
@tabId = i.Tab_ID, @typeCd=i.Type_CD, @description=i.Description,
@position=i.FieldPosition, @required=i.Required, @typeCat=i.Type_CAT,
@ufprofileID=i.UserFieldProfile_ID,@changeBy=i.ChangeBy
from inserted i

update userfield
set
Tab_ID=@tabId,
Type_CD=@typeCd,
Description=@description,
FieldPosition=@position,
Required=@required,
Type_CAT=@typeCat,
ChangeBy=@changeBy,
LastChange=GETDATE()
where UserFieldProfile_ID=@ufprofileID
END


go


grant execute  on getGridList to <LOGIN>
go


insert into DatabaseHistory values
(
  '8.11.0.39.00',
  '07-OCT-2020',
  'Suite81103800-81103900-SQL.sql',
  'Upgrades the database from 8.11.0.38.00 to 8.11.0.39.00.',
  GETDATE()
)
go